// harmonicFunHW.ck
// MUSC 208 Homework 11-12
// John Ellinger Carleton College Winter 2014

16 => int MAX_HARMONICS;
SinOsc harmSinOsc[ MAX_HARMONICS ]; // 16 chuck sound generators
float f0;							// fundamental frequency is harmSinOsc[0].freq
float harmGain[ MAX_HARMONICS ];	// GUI values of the 16 sliders
float harmOnOff[ MAX_HARMONICS ];	// GUI values of the 16 checkboxes
float dutyCycle;					// GUI value of the duty cycle slider
float volKnob;						// GUI value of volume knob
int wavType; 						// GUI value of wave type
									// 1 2 3 4 5 are sine saw square triangle pulse
Impulse imp; 						// specific to pulse wav

//Write to wav file - set to 0 or 1
0 => int isWritingWavFile;
WvOut w;
if ( isWritingWavFile )
{
	dac => w => blackhole;
	w.wavFilename( me.sourceDir() + "/harmonicTest.wav" );
}

// initialize all variables to a default state
function void setup()
{	
	220 => f0;
	1 => int wavType; // 1 2 3 4 5 are sine saw square triangle pulse
	0.5 => dutyCycle;
	1.0 => volKnob; 
	for ( 0 => int ix; ix < MAX_HARMONICS; ix++ )
	{
		harmSinOsc[ix] => dac;
		f0 * (ix+1) => harmSinOsc[ix].freq; // setup the harmonic series
		0 => harmGain[ ix ];
		0 => harmOnOff[ ix ];
		0 => harmSinOsc[ ix ].gain;
	}
	1.0 => harmGain[ 0 ];
	1 => harmOnOff[ 0 ];
	volKnob * calcAmpScaleFactor() * harmGain[ 0 ] => harmSinOsc[ 0 ].gain;
}

// call the setup function
//setup();


// create our OSC receiver to listen for events from GUI
OscRecv recv;
// use port 12346 defined in Processing code
12346 => recv.port;

// the OscEvent "" names in ChucK MUST match the names defined in Processing
// create an address in the receiver, store in new variable
recv.event( "/toChuck/harmAmp, ffffffffffffffff" ) @=> OscEvent oeAmp;
recv.event( "/toChuck/harmOnOff, ffffffffffffffff" ) @=> OscEvent oeOnOff;
recv.event( "/toChuck/play" ) @=> OscEvent oePlay;
recv.event( "/toChuck/stop" ) @=> OscEvent oeStop;
recv.event( "/toChuck/volume, f" ) @=> OscEvent oeVol;
recv.event( "/toChuck/duty, f" ) @=> OscEvent oeDuty;
recv.event( "/toChuck/wave, i" ) @=> OscEvent oeWave;

// start listening (launch thread)
recv.listen();

// OSC Listeners functions will be sporked later
function void listenForHarmonicAmplitudes() 
{
	float amp;
	while ( true )
	{
		// wait for event to arrive
		oeAmp => now;
		// grab the next message from the queue. 
		<<< "OSC/harmAmp message received", "" >>>;
		
		while ( oeAmp.nextMsg() != 0 )
		{ 
			// getFloat fetches the expected float (as indicated by "f")
			for ( 0 => int ix; ix < MAX_HARMONICS; ix++ )
			{
				oeAmp.getFloat() => amp;
				amp  =>  harmGain[ix];
			}			
		}
		updateHarmGain();
	}
}

// OSC Listeners
function void listenForHarmonicOnOff() 
{
	float onOff;
	while ( true )
	{
		// wait for event to arrive
		oeOnOff => now;
		// grab the next message from the queue. 
		<<< "OSC/harmOnOff message received", "" >>>;
		
		while ( oeOnOff.nextMsg() != 0 )
		{ 
			// getFloat fetches the expected float (as indicated by "f")
			for ( 0 => int ix; ix < MAX_HARMONICS; ix++ )
			{
				oeOnOff.getFloat() => onOff;
				onOff => harmOnOff[ix];
			}	
		}
		updateHarmOnOff();
	}
}

function void listenForPlay() 
{
	while ( true )
	{
		oePlay => now;
		// grab the next message from the queue. 
		while ( oePlay.nextMsg() != 0 )
		{ 
			<<< "OSC/play message received)", "" >>>;
			doPlay();
		}
	}
}

function void listenForStop() 
{
	while ( true )
	{
		oeStop => now;
		// grab the next message from the queue. 
		while ( oeStop.nextMsg() != 0 )
		{ 
			<<< "OSC/stop message received", "" >>>;
			doStop();
		}
	}
}

function void listenForVolume() 
{
	float vol;
	while ( true )
	{
		oeVol => now;
		// grab the next message from the queue. 
		while ( oeVol.nextMsg() != 0 )
		{ 
			oeVol.getFloat() => vol;
			<<< "OSC/volume message received", vol >>>;
			updateVolume( vol );
		}
	}
}

function void listenForDutyCycle() 
{
	float duty;
	while ( true )
	{
		oeDuty => now;
		// grab the next message from the queue. 
		while ( oeDuty.nextMsg() != 0 )
		{ 
			oeDuty.getFloat() => duty;
			<<< "OSC/duty message received", duty >>>;
			updateDutyCycle( duty );
		}
	}
}

function void listenForWaveType() 
{
	int wt;
	while ( true )
	{
		oeWave => now;
		// grab the next message from the queue. 
		while ( oeWave.nextMsg() != 0 )
		{ 
			oeWave.getInt() => wt;
			wt => wavType;
		}
		wt => wavType;
		<<< "OSC/wave message received", wavType >>>;
	}
}

function void updateHarmGain()
{
	// the current values of the 16 GUI sliders are in the harmGain[] array
	<<< "updateHarmGain()", "" >>>;
	for ( 0 => int ix; ix < MAX_HARMONICS; ix++ )
	{
		<<< "harmGain[", ix,"]", harmGain[ix] >>>;   
	}
	<<< "*** wavType is", wavType >>>;
}

function void updateHarmOnOff()
{
	// the current values of the 16 GUI sliders are in the harmGain[] array
	<<< "updateHarmOnOff()", "" >>>;
	for ( 0 => int ix; ix < MAX_HARMONICS; ix++ )
	{   
		<<< "\tharmOnOff[", ix,"]", harmOnOff[ix] >>>;
	}
}

function void doPlay()
{
	// play current settings
	<<< "\tdoPlay()", "" >>>;
}

function void doStop()
{
	// stop all sound
	<<< "\tdoStop()", "" >>>;
}

function void updateVolume( float vol )
{
	// adjust the overall volume according to the volume knob
	<<< "\tupdateVolume() volKnob", vol >>>;
}

function void updateDutyCycle( float dc )
{
	<<< "\tupdateDutyCycle()", dc >>>;
	dc => dutyCycle;
}

function void doSines()
{
	// set gains for sinOsc[] array to match GUI
	<<< "\tdoSines()", "" >>>;
}

function void doSaw()
{
	// set gains for sinOsc[] array to match GUI
	<<< "\tdoSaw()", "" >>>;
}

function void doSquare()
{
	// set gains for sinOsc[] array to match GUI
	<<< "\tdoSquare()", "" >>>;
}

function void doTriangle()
{
	// set gains for sinOsc[] array to match GUI
	<<< "\tdoTriangle()", "" >>>;
}

function void genPulse()
{
	<<< "ENTERING genPulse()", wavType >>>;
	second/samp => float SR;	
	// Impulse imp; is declared at top but is not connected to dac;
	// Use the Impulse function to create a wave that is either +1.0 or -1.0
	// based on the frequency f0 and the dutyCycle (percent of 1.0's over total
	// number of samples in one period of f0 at sample rate SR
	// Pulse wave gain is  harmSinOsc[0] setting;
	// connect imp to dac
	// calculate how many SR samples would occur in one period of global frequency f0
	// get the dutyCycle or percent that the impulse = 1
	// sampOnePeriod * dutyCycle is the number of samples of value 1.0
	// 1.0 => imp.next for that many samples
	// chuck each 1.0 sample to now
	// number remaining in sampOnePeriod will have value -1.0
	// chuck each -1.0 sample to now
	// repeat when number of samples chucked is equal to one period of f0 samples
	// continue to repeat until user chooses another wave type and then
	// disconnect imp from dac	
	<<< "EXITING genPulse()", wavType >>>;
}

function void doPulse( float duty )
{
	<<< "\tdoPulse()", duty >>>;
	genPulse();
}

function void zeroAllSinOscGains()
{
	// set all harmSinOsc[] gains to 0, no sound
}

function void resetAllSinOscGains()
{
	// update harmGain[] based on values of GUI sliders
}

function int countHarmOn()
{
	// count number of GUI harmonic checkboxes that are On
}

function float calcAmpScaleFactor()
{
	float scaleFactor;
	
	if ( wavType == 1 ) // sine
		// set amplitude scale factor based on number of
		// GUI harmonics that are on
		// empty statement to avoid compile error
		;
	else if  ( wavType == 2 ) // saw
		// amplitude scale factor from Lab 11 saw wave formula 
		// empty statement to avoid compile error
		;
	else if  ( wavType == 3 ) // square
		// amplitude scale factor from Lab 11 square wave formula 
		// empty statement to avoid compile error
		;
	else if  ( wavType == 4 ) // triangle
		// amplitude scale factor from Lab 11 triangle wave formula 
		// empty statement to avoid compile error
		;
	else if  ( wavType == 5 ) // pulse
		// amplitude scale factor - whatever sounds good
		// empty statement to avoid compile error
		;
	
		return scaleFactor;	
}

// call the setup function
setup();

// spork the OSC listeners to listen for events from GUI
spork ~ listenForHarmonicAmplitudes();
spork ~ listenForHarmonicOnOff();
spork ~ listenForPlay();
spork ~ listenForStop();
spork ~ listenForVolume();
spork ~ listenForDutyCycle();
spork ~ listenForWaveType();

// let it run
<<< "Listening for GUI controls","" >>>;
10::minute => now;

if ( isWritingWavFile )
	null @=> w; // close the wav file

