// harmonicFunHW.pde
// MUSC 208 Homework 11-12
// John Ellinger Carleton College Winter 2014

import oscP5.*;
import netP5.*;
import controlP5.*;
 
Boolean firstDraw = true;

ControlP5 cp5;
int bkgColor = color(248);
int foreColor = color(248);
int activeColor = color(0, 248, 0);

int MAX_HARMONICS = 16;
Slider[] harmSlider = new Slider[MAX_HARMONICS];
String[] sliderLabels = { "H1","H2","H3","H4","H5","H6","H7","H8",
"H9","H10","H11","H12","H13","H14","H15","H16" };

CheckBox chkbox;
float[] harmOnOff = new float[ MAX_HARMONICS ];

RadioButton wavBtns;
float sinBtn = 1.0;
float sawBtn = 2.0;
float squareBtn = 3.0;
float triangleBtn = 4.0;
float pulseBtn = 5.0;
int wavType;

Slider dutySlider;
Knob volumeKnob;
Button playBtn;
Button stopBtn;

// OSC stuff
OscP5 oscP5; // OscP5 is name of class, oscP5 is a variable instance of that class
// the addresses you'll send to
NetAddress ChuckAddress;

void addGUIControls()
{
  PFont pfont = createFont("Arial",12,true); // use true/false for smooth/no-smooth
  ControlFont font = new ControlFont(pfont,241);
  float val;
  int dx = 50;
  for ( int ix = 0; ix < MAX_HARMONICS; ix++ )
  {  
     if ( ix == 0 )
       val = 1.0;
    else
       val = 0.0;

     cp5.addSlider( sliderLabels[ix] )
       .setPosition(20 + ix*dx, 80)
       .setSize( 20, 500 )
       .setRange(0, 1.0)
       .setValue( val )
       .setColorCaptionLabel(0) 
       .setColorValueLabel(0) 
       .setDecimalPrecision(3) 
       .setColorBackground(color(128))
       .setColorForeground(color(0,248,0))
       .setColorActive(color(0,248,0))
     ;
     
    cp5.getController(sliderLabels[ix])
     .getCaptionLabel()
     .setFont(font)
     .toUpperCase(true)
     .setSize(14)
     ;
     
  }
  
  chkbox = cp5.addCheckBox( "chkOnOff" )
    .setPosition(20, 610)
    .setColorBackground(color(128))
    .setColorForeground(color(128))
    .setColorActive(color(0,248,0))
    .setColorLabel(color(0))
    .setSize(20, 20)
    .setItemsPerRow(MAX_HARMONICS)
    .setSpacingColumn(30)
    .setSpacingRow(0)
    .addItem("1", 1 )
    .addItem("2", 2 )
    .addItem("3", 3 )
    .addItem("4", 4 )
    .addItem("5", 5 )
    .addItem("6", 6 )
    .addItem("7", 7 )
    .addItem("8", 8 )
    .addItem("9", 9 )
    .addItem("10", 10 )
    .addItem("11", 11 )
    .addItem("12", 12 )
    .addItem("13", 13 )
    .addItem("14", 14 )
    .addItem("15", 15 )
    .addItem("16", 16 )
    ;

  wavBtns = cp5.addRadioButton("wavBtns")
         .setPosition(20,20)
         .setSize(40,20)
         .setColorLabel( 0 )
         .setItemsPerRow(5)
         .setSpacingColumn(100)
         .setColorForeground( color(128) )
         .setColorBackground( color(128) )
         .setColorActive( color(255,255,162) )
         .setMouseOver(false) 
         .setNoneSelectedAllowed(false)
         .addItem("Sines", 1)
         .addItem("Saw", 2)
         .addItem("Square", 3)
         .addItem("Triangle", 4)
         .addItem("Pulse", 5)
         ;
 
 cp5.getController("Sines")
     .getCaptionLabel()
     .setFont(font)
     .toUpperCase(false)
     .setSize(14)
     ;
     
 cp5.getController("Saw")
     .getCaptionLabel()
     .setFont(font)
     .toUpperCase(false)
     .setSize(14)
    ;
    
 cp5.getController("Square")
     .getCaptionLabel()
     .setFont(font)
     .toUpperCase(false)
     .setSize(14)
     ;
     
 cp5.getController("Triangle")
     .getCaptionLabel()
     .setFont(font)
     .toUpperCase(false)
     .setSize(14)
     ;
     
 cp5.getController("Pulse")
     .getCaptionLabel()
     .setFont(font)
     .toUpperCase(false)
     .setSize(14)
     ;
 
dutySlider = cp5.addSlider( "Duty Cycle" )
       .setPosition(580, 50)
       .setSize( 100, 12 )
       .setRange(.05, .95)
       .setValue( .50 )
       .setColorCaptionLabel(0) 
       .setColorValueLabel(0) 
       .setDecimalPrecision(2) 
       .setColorBackground(color(128))
       .setColorForeground(color(255,255,162))
       .setColorActive(color(255,255,162))
     ;

cp5.getController("Duty Cycle")
     .getCaptionLabel()
     .setFont(font)
     .toUpperCase(false)
     .setSize(12)
     ;
   
 volumeKnob = cp5.addKnob("Volume")
     .setRange(0,1.0)
     .setValue(1.0)
     .setPosition(820, 80)
     .setRadius(30)
     .setDragDirection(Knob.VERTICAL)
     .setColorLabel( 0 )
     ;

 cp5.getController("Volume")
     .getCaptionLabel()
     .setFont(font)
     .toUpperCase(false)
     .setSize(14)
     ;
     
  PImage[] imgs = {loadImage("button_a.png"),loadImage("button_b.png"),loadImage("button_c.png")};
  playBtn = cp5.addButton("playBtn")
     .setValue(128)
     .setPosition(820,200)
     .setImages(imgs)     
     .updateSize()
     ;
  
  PImage[] imgs2 = {loadImage("button_d.png"),loadImage("button_e.png"),loadImage("button_f.png")};
  stopBtn = cp5.addButton("stopBtn")
     .setValue(129)
     .setPosition(820,280)
     .setImages(imgs2)     
     .updateSize()
     ;

 } // end addGUIControls

void setup() 
{
  size(900, 640); // set size of window
  noStroke();     // no aliasing
  
  cp5 = new ControlP5(this);
  addGUIControls();
  
  // fill in the harmonic slider control array to make accessing individual sliders easier
  for ( int ix = 0; ix < MAX_HARMONICS; ix++ )
  {
      harmSlider[ix] = (Slider)cp5.getController(sliderLabels[ix]);
      harmOnOff[ix] = 0;
  }
  harmOnOff[0] = 1;

// OSC stuff
// (if you're networked with another computer; use it's ip#) 
// if ChucK were to send back to Processing it would send to port 12345
  oscP5 = new OscP5(this,  12345); 
  
  // Processing will send to ChucK on port 12346
  // 127.0.0.1 is the network address of the local machine
  // port 12346 must be defined in harmonicFun.ck as the receive port
  ChuckAddress = new NetAddress("127.0.0.1",  12346);
}

void draw() 
{
  rect(0, 0, width, height);
  // a gray window background
  background( color(192) ); 
  if ( firstDraw )
  {
    chkbox.deactivateAll();
    wavBtns.activate(0);
    sendOSCHarmAmp();
    firstDraw = false; // don't do it again
  }
}

void doSines()
{
   harmSlider[0].setValue( 1.0 );
   chkbox.deactivateAll();
   chkbox.getItem(0).setValue( 1 );

   for (int ix = 1; ix < MAX_HARMONICS; ix++ )
   {
         cp5.getController( sliderLabels[ ix ] ).setValue( 0 );
   }
 }

void doSaw()
{
   for ( int ix = 1; ix <= MAX_HARMONICS; ix++  )
   {
      harmSlider[ ix-1 ].setValue( 1.0/ix );
      chkbox.getItem(ix-1).setValue( 1 );   
   }
 }

void doSquare()
{
   harmSlider[ 0 ].setValue( 1.0 );
   chkbox.getItem(0).setValue( 1 );   
   for ( int ix = 1; ix <= MAX_HARMONICS; ix++  )
   {
       if ( ix % 2 == 1 )
       {
         harmSlider[ ix-1 ].setValue( 1.0/ix );
         chkbox.getItem(ix-1).setValue( 1 );   
       }
       else
       {
         harmSlider[ ix-1 ].setValue( 0 );
         chkbox.getItem(ix-1).setValue( 0 );   
       }
    }
 }

void doTriangle()
{
   harmSlider[ 0 ].setValue( 1.0 );
   chkbox.getItem(0).setValue( 1 );   
   for ( int ix = 1; ix <= MAX_HARMONICS; ix++  )
   {
       if ( ix % 2 == 1 )
       {
         harmSlider[ ix-1 ].setValue( 1.0/(ix*ix) );
         chkbox.getItem(ix-1).setValue( 1 );   
       }
       else
       {
         harmSlider[ ix-1 ].setValue( 0 );
         chkbox.getItem(ix-1).setValue( 0 );   
       }
    }
 }

void doPulse()
{
   chkbox.deactivateAll();
   for (int ix = 1; ix < MAX_HARMONICS; ix++ )
   {
       harmSlider[0].setValue( 0 );
       cp5.getController( sliderLabels[ ix ] ).setValue( 0 );
   }
   harmSlider[0].setValue( 1.0 );
   chkbox.getItem(0).setValue( 1 );

}

void sendOSCHarmAmp()
{
  //the OscMessage class has handy formatting methods
  OscMessage oscHarmAmp = new OscMessage("/toChuck/harmAmp"); //greate the address
  float outAmp;
   for ( int ix = 0; ix < MAX_HARMONICS; ix++ )
  {
    outAmp = 0;
    if ( harmOnOff[ix] == 1 )
      outAmp = harmSlider[ix].getValue();
      
    oscHarmAmp.add( outAmp );//append these items
  }
  oscP5.send(oscHarmAmp, ChuckAddress);//send the message
}

void sendOSCHarmOnOff() 
{
  //the OscMessage class has handy formatting methods
  OscMessage oscHarmOnOff = new OscMessage("/toChuck/harmOnOff"); //greate the address
  float onOff;
  for ( int ix = 0; ix < MAX_HARMONICS; ix++ )
  {
    onOff = 0;
    if ( chkbox.getArrayValue()[ix] == 1 )
       onOff = 1;
    
    harmOnOff[ix] = onOff;
     
   oscHarmOnOff.add( onOff );//append these items
  
  }
  oscP5.send(oscHarmOnOff, ChuckAddress);//send the message
}

void sendOSCFreq( float freq )
{
  //the OscMessage class has handy formatting methods
  // send as MIDI note number
  OscMessage oscFreq = new OscMessage("/toChuck/freq");//greate the address
  oscFreq.add( freq ); //append these items
  oscP5.send(oscFreq, ChuckAddress);//send the message
}

void sendOSCDuty( float duty )
{
  //the OscMessage class has handy formatting methods
  OscMessage oscDutyCycle = new OscMessage("/toChuck/duty");//greate the address
  oscDutyCycle.add( duty ); //append these items
  oscP5.send(oscDutyCycle, ChuckAddress);//send the message
}

void sendOSCPlay() 
{
  //the OscMessage class has handy formatting methods
  OscMessage oscDoPlay = new OscMessage("/toChuck/play");//greate the address
  oscP5.send(oscDoPlay, ChuckAddress);//send the message
}

void sendOSCStop() 
{
  //the OscMessage class has handy formatting methods
  OscMessage oscDoPlay = new OscMessage("/toChuck/stop");//greate the address
  oscP5.send(oscDoPlay, ChuckAddress);//send the message
}

void sendOSCWaveType( int wt ) 
{
  //the OscMessage class has handy formatting methods
  OscMessage oscWavType = new OscMessage("/toChuck/wave");//greate the address
  oscWavType.add( wt ); //append these items
  oscP5.send(oscWavType, ChuckAddress);//send the message
}

void sendOSCVolume( float vol )
{
  //the OscMessage class has handy formatting methods
  OscMessage oscVolume = new OscMessage("/toChuck/volume");//greate the address
  oscVolume.add( vol ); //append these items
  oscP5.send(oscVolume, ChuckAddress);//send the message
}

void controlEvent(ControlEvent theEvent)
{
    Boolean fromHarmonic = false;
    for ( int ix = 0; ix < MAX_HARMONICS; ix++ )
    {
        if ( theEvent.isFrom( harmSlider[ ix ] ) )
        {
            fromHarmonic = true;
            if ( harmSlider[ ix ].getValue() > 0 )
              chkbox.getItem(ix).setValue( 1 ); 
            else
              chkbox.getItem(ix).setValue( 0 ); 
            break;
        }
    }
    if ( fromHarmonic  )
    {
       sendOSCHarmAmp();      
       println( "got an event from Slider");
    }
   
    if ( theEvent.isFrom(chkbox) ) 
    {
       sendOSCHarmOnOff();      
       println( "got an event from "+chkbox.getName());
    }
 
    if (theEvent.isFrom( wavBtns )) 
    {
       if ( theEvent.getValue() == sinBtn )
       {
         println( "doSines()" );
         wavType = (int)sinBtn;
         sendOSCWaveType( wavType );
         doSines();
       }
       else if ( theEvent.getValue() == sawBtn )
       {
         println( "doSaw()" );
         wavType = (int)sawBtn;
         sendOSCWaveType( wavType );
         doSaw();
       }
       else if ( theEvent.getValue() == squareBtn )
       {
         println( "doSquare()" );
         wavType = (int)squareBtn;
         sendOSCWaveType( wavType );
         doSquare();
       }
       else if ( theEvent.getValue() == triangleBtn )
       {
         println( "doTriangle()" );
         wavType = (int)triangleBtn;
         sendOSCWaveType( wavType );
         doTriangle();
       }
       else if ( theEvent.getValue() == pulseBtn )
       {
         println( "doPulse()" );
         wavType = (int)pulseBtn;
         sendOSCWaveType( wavType );
         doPulse();
       }
     }
    
     if (theEvent.isFrom( dutySlider )) 
    {
          float duty = dutySlider.getValue();
          sendOSCDuty( duty );
          println( "sendOSCDuty "+duty );
    }
    
    if (theEvent.isFrom( playBtn )) 
    {
          sendOSCPlay();
          println( "sendOSCPlay()" );
    }
   
    if (theEvent.isFrom( stopBtn )) 
    {
          sendOSCStop();
          println( "sendOSCStop()" );
   }
   
    if (theEvent.isFrom( volumeKnob )) 
    {
          float vol = volumeKnob.getValue();
          sendOSCVolume( vol );
          println( "sendOSCVolume "+vol );
    }
}
